
(define chinese:table-source "/home/mflatt/dicts/TONEPY.tit")

(define chinese:font-family 
  (send wx:the-font-name-directory get-new-family-id))
(send wx:the-font-name-directory initialize chinese:font-family "Chinese")

(define chinese:font (make-object wx:font%
				  16 chinese:font-family
				  wx:const-normal wx:const-normal #f))

(define chinese:pinyin (make-hash-table))
(let ([p (open-input-file chinese:table-source)]
      [read-line
       (lambda (p)
	 (let ([c (read-char p)])
	   (if (eof-object? c)
	       c
	       (list->string
		(cons c
		      (let loop ()
			(let ([c (read-char p)])
			  (if (or (eof-object? c) 
				  (char=? c #\newline)
				  (char=? c #\return))
			      '()
			      (cons c (loop))))))))))]
      [remove-space
       (lambda (str)
	 (list->string
	  (let loop ([l (string->list str)])
	    (cond
	     [(null? l) '()]
	     [(char=? #\space (car l)) (loop (cdr l))]
	     [else (cons (car l) (loop (cdr l)))]))))])
  (dynamic-wind
   (lambda () #f)
   (lambda ()
     (let loop ()
       (let ([c (read-line p)])
	 (unless (or (eof-object? c) (equal? c "BEGINDICTIONARY"))
	    (loop))))
     (let loop ()
       (let ([c (read-line p)])
	 (unless (eof-object? c)
	    (unless (string=? "#" (substring c 0 1))
	       (hash-table-put!
		chinese:pinyin
		(string->symbol (remove-space (substring c 0 8)))
		(let loop ([str (string->list
				 (substring c 8 (string-length c)))])
		  (display str) (newline)
		  (if (null? str)
		      '()
		      (cons (string (car str) (cadr str) #\null #\null)
			    (loop (cddr str)))))))
	    (loop)))))
   (lambda ()
     (close-input-port p))))
     

(define chinese:snip%
  (make-class wx:snip%
      (private 
       [contents '()]
       [bundle-contents
	(lambda ()
	  (list->string
	   (let loop ([l contents])
	     (if (null? l)
		 (list #\null #\null)
		 (cons (integer->char (+ #x80 (char->integer (car l))))
		       (loop (cdr l)))))))]
       [resized
	(lambda ()
	  (let ([admin ((ivar get-admin))])
	    (unless (null? admin)
		    (send admin resized this #t))))])
      (public
       [get-extent
	(lambda (dc x y wbox hbox descentbox spacebox
		    lspacebox rspacebox)
	  (let ([font (send dc get-font)])
	    (send dc set-font chinese:font)
	    (send dc get-text-extent (bundle-contents)
		  (if (null? wbox) (box 0) wbox) 
		  (if (null? hbox) (box 0) hbox)
		  descentbox spacebox () #t)
	    (send dc set-font font))
	  (if (not (null? rspacebox))
	      (set-box! rspacebox 0))
	  (if (not (null? lspacebox))
	      (set-box! lspacebox 0)))]
	[draw
	 (lambda (dc x y . other)
	   (let ([font (send dc get-font)])
	    (send dc set-font chinese:font)
	    (send dc draw-text (bundle-contents) x y #t)
	    (send dc set-font font)))]
	[set
	 (lambda (str)
	   (set! contents (string->list str))
	   (resized))]
	[add
	 (lambda (str)
	   (set! contents (append contents (string->list str)))
	   (resized))])))


(define dc (send mred:console-canvas get-dc))
(define s (make-object chinese:snip%))
(send s set "ma")

(define w (box 0))
(define h (box 0))
