
/* Example dynamically-loaded MzScheme extension */

#include "escheme.h"
#include <time.h>

static Scheme_Object *sch_date(int argc, Scheme_Object **argv)
{
  time_t clock;
  struct tm *now;
  char *str;

  if (argc)
    scheme_wrong_count("date", 1, 1, argc, argv);

  time(&clock);
  now = localtime(&clock);
  str = asctime(now);

  /* Get rid of newline */
  str[24] = 0;

  return scheme_make_string(str);
}

void scheme_initialize(Scheme_Env *env)
{
  scheme_add_global("date", scheme_make_prim(sch_date), env);
}
