; Dan Grossman
; Hyper Frame
; July 17, 1995

(load "edit.ss")
(load "dialog.ss")

(define mred:hyper-frame-group (make-object mred:std-frame-group%))

(define mred:hyper-canvas%
  (make-class mred:canvas%
    (class 
      [edit% mred:hyper-edit%])
    (inherit get-media get-client-size set-focus on-paint)
    (public
      [on-size  ; all word-wrapping, all the time.
       (lambda (width height)
	 ((ivar super on-size) width height)
	 (set-wrap )
	 (set-focus ))]
      [set-wrap 
       (lambda ()
	 (let ([width-holder (box 0)])
	   (get-client-size width-holder (box 0))
	   (send (get-media) set-max-width  (- (unbox width-holder) 10))))]
      [history-stack ()]
      [forward-stack ()]
      [home #f] 
      [locked? #t]
      [set-locking  (lambda (val) (set! locked? val))]
      [set-history 
       (lambda (stack)
	 (set! history-stack stack))]
      [set-forward 
       (lambda (stack)
	 (set! forward-stack stack))]
      [set-home 
       (lambda (tag)
	 (set! home (cons (get-media) tag)))]
      [adjust-stacks-on-follow 
       (lambda (tag)
	 (set-history  (cons (cons (get-media) tag)
			     history-stack))
	 (set-forward  ()))]
      [position-to-top
       (lambda ()
	 (let* ([edit (get-media)]
		[bt (box 0)][bb (box 0)]
		[this-line (send edit position-line 
				 (send edit get-start-position))])
	   (send edit get-visible-line-range bt bb)
	   (send edit scroll-to-position 
		 (send edit line-start-position this-line) #t
		 (send edit line-start-position
		       (+ this-line (- (unbox bb)(unbox bt)))))))]
      [do-tag
       (lambda ()
	 (let ([tag the-tag]
	       [edit (get-media)])
	   (unless (null? edit)
	     (send edit begin-edit-sequence)
	     (set-wrap)
	     (if tag
		 (let tag-loop ([tags-left (ivar edit hypertags-list)])
		   (cond
		     [(null? tags-left)
		      (send edit show-message"Unable to find destination position."
			    "Error")]
		     [(string=? tag (mred:hypertag-name (car tags-left)))
		      (send edit set-position 
			    (mred:hypertag-position (car tags-left)))]
		     [else (tag-loop (cdr tags-left))])))
	     (position-to-top)
	     (send edit end-edit-sequence))
	   (on-paint)
	   (adjust-stacks-on-follow tag)
	   (set-the-tag #f)))]
      [the-tag #f]
      [set-the-tag (lambda (tag) (set! the-tag tag))]
      [set-media  (lambda (edit)
		    ((ivar super set-media) edit #f)
		    (do-tag))])))

     
; a simple frame w/ a file close and always locked.
; now with buttons:

(define mred:hyper-view-frame%
  (let-enumerate ([FILE-CLOSE
		  
		  END-OF-MENUS])
    (make-class mred:frame%
      (inherit active-canvas edit active-edit TOP-MARGIN LEFT-MARGIN)
      (class
	[edit% mred:hyper-edit%]
	[canvas% mred:hyper-canvas%]
	[button% wx:button%]
	[menu% wx:menu%]
	[menu-bar% wx:menu-bar%]
	[panel% wx:panel%])
      (private
	button-panel
	backward-button
	forward-button
	home-button
	[do-backward
	 (lambda (button event)
	   (let* ([canvas (active-canvas)]
		  [backs (ivar canvas history-stack)]
		  [fors (ivar canvas forward-stack)])
	     (when (not (or (null? backs)(null? (cdr backs))))
	       (send canvas set-the-tag (cdadr backs))
	       (send canvas set-media  (caadr backs))
	       (send canvas set-history  (cdr backs))
	       (send canvas set-forward  (cons (car backs) fors)))
	     (send canvas set-focus )))]
	[do-forward
	 (lambda (button event)
	   (let* ([canvas (active-canvas)]
		  [backs (ivar canvas history-stack)]
		  [fors (ivar canvas forward-stack)])
	     (when (not (null? fors))
	       (send* canvas
		      (set-the-tag (cdar fors))
		      (set-media  (caar fors))
		      (set-history  (cons (car fors) backs))
		      (set-forward  (cdr fors))))
	     (send canvas set-focus )))]
	[do-home
	 (lambda (button event)
	   (let* ([canvas (active-canvas)]
		  [backs (ivar canvas history-stack)]
		  [home (ivar canvas home)])
	     (when home
	       (send* canvas
		      (set-the-tag (cdr home))
		      (set-media  (car home))
		      (set-history  (cons home backs))
		      (set-forward  ())))
	     (send canvas set-focus )))])
      (public
	[on-menu-command
	 (lambda (op)
	   (= op FILE-CLOSE)
	   ((ivar show ) #f))]
	[make-menu-bar
	 (lambda ()
	   (let ([file-menu (make-object menu%)])
	     (send file-menu append  FILE-CLOSE "Close")
	     (make-object wx:menu-bar% (list file-menu)(list "File"))))]
	[open-file 
	 (opt-lambda (filename [tag #f])
	   (send (active-canvas) set-the-tag tag)
	   ((ivar super open-file) filename))])
      (opt-lambda ([file-name #f][keep-locked? #t][tag "top"][relative? #f])
	(super-init file-name #t mred:hyper-frame-group)
	(set! button-panel (make-object panel% this))
	(set! backward-button
	      (make-object button% 
			   button-panel do-backward "Back"))
	(set! forward-button
	      (make-object button%
			   button-panel do-forward "Forward"))
	(set! home-button
	      (make-object button%
			   button-panel do-home "Home"))
	(send button-panel new-line)
	(send button-panel fit)
	(let ([w (box 0)][h (box 0)])
	  (send button-panel get-size w h)
	  (send button-panel set-size LEFT-MARGIN TOP-MARGIN 1000 (unbox h))
	  (set! TOP-MARGIN (+ TOP-MARGIN (unbox h))))
	((ivar on-size) 0 0)
	(send (active-canvas) set-focus)
	(send (active-canvas) set-home tag)
	(send (active-canvas) set-history ())
	(send (active-canvas) adjust-stacks-on-follow tag)))))

(define mred:hyper-make-frame%
  (let-enumerate    
      ([H-MAKE-LINK
	H-REMOVE-LINK-HERE
	H-CHANGE-LINK
	H-FOLLOW-ON-CLICK
	H-VIEW-ON-CLICK
	H-NOTHING-ON-CLICK
	H-MAKE-TAG-HERE
	H-SHOW-TAG
	H-REMOVE-TAG
	
	END-OF-MENUS])
    (make-class mred:hyper-view-frame%
      (inherit active-edit active-canvas)
      (class
	[edit% mred:hyper-edit%]
	[canvas% mred:hyper-canvas%]
	[menu% mred:menu%]
	[menu-bar% mred:menu-bar%])
      (private
	menu-offset
	menu-bar)
      (public
	[make-edit
	 (lambda ()
	   (make-object edit% #f))]
	[next-menu-id    
	 (lambda ()
	   (+ END-OF-MENUS menu-offset))]
	[on-menu-command 
	 (lambda (op)
	   (if (< op menu-offset)
	       ((ivar mred:frame% on-menu-command) op)
	       (let ([op (- op menu-offset)]
		     [edit (active-edit)])
		 (cond
		   [(= op H-MAKE-LINK)
		    (send edit make-link
			  (send edit get-start-position)
			  (send edit get-end-position))]
		   [(= op H-REMOVE-LINK-HERE)
		    (send edit remove-link 
			  (send edit get-start-position))]
		   [(= op H-CHANGE-LINK)
		    (send edit change-link (send edit get-start-position))]
		   [(= op H-FOLLOW-ON-CLICK)
		    (send edit install-clickbacks )
		    (send edit set-follow-on-click  #t)
		    (send menu-bar check  (+ menu-offset H-FOLLOW-ON-CLICK) #t)
		    (send menu-bar check  (+ menu-offset H-VIEW-ON-CLICK) #f)
		    (send menu-bar check  (+ menu-offset H-NOTHING-ON-CLICK) #f)]
		   [(= op H-VIEW-ON-CLICK)
		    (send edit install-clickbacks )
		    (send edit set-follow-on-click  #f)
		    (send menu-bar check  (+ menu-offset H-FOLLOW-ON-CLICK) #f)
		    (send menu-bar check  (+ menu-offset H-VIEW-ON-CLICK) #t)
		    (send menu-bar check  (+ menu-offset H-NOTHING-ON-CLICK) #f)]
		   [(= op H-NOTHING-ON-CLICK)
		    (send edit uninstall-clickbacks )
		    (send edit set-follow-on-click  ())
		    (send menu-bar check  (+ menu-offset H-FOLLOW-ON-CLICK) #f)
		    (send menu-bar check  (+ menu-offset H-VIEW-ON-CLICK) #f)
		    (send menu-bar check  (+ menu-offset H-NOTHING-ON-CLICK) #t)]
		   [(= op H-MAKE-TAG-HERE)
		    (send edit make-tag 
			  (send edit get-start-position))]
		   [(= op H-REMOVE-TAG)
		    (let ([tag-name (send (make-object 
					   tag-dialog% 
					   (reverse
					    (map mred:hypertag-name 
						 (ivar edit hypertags-list))))
					  get-answer)])
		      (if tag-name (send edit remove-tag  tag-name)))]
		   [(= op H-SHOW-TAG)
		    (let ([tag-name (send (make-object 
					   tag-dialog% 
					   (reverse
					    (map mred:hypertag-name 
						 (ivar edit hypertags-list))))
					  get-answer)])
		      (if tag-name (send edit show-tag tag-name)))]
		   ))))]
	[make-menu-bar
	 (lambda ()
	   (set! menu-bar ((ivar mred:frame% make-menu-bar)))
	   (let ([hyper-menu (make-object menu%)]
		 [offset ((ivar mred:frame% next-menu-id))])
	     (send hyper-menu append  (+ offset H-MAKE-LINK) 
		   "New Link...")
	     (send hyper-menu append  (+ offset H-CHANGE-LINK)
		   "Change Link...")
	     (send hyper-menu append  (+ offset H-REMOVE-LINK-HERE)
		   "Remove Link")
	     (send hyper-menu append-separator )
	     (send hyper-menu append  (+ offset H-FOLLOW-ON-CLICK)
		   "Follow Links" "" #t)
	     (send hyper-menu append  (+ offset H-VIEW-ON-CLICK)
		   "Display Links" "" #t)
	     (send hyper-menu append  (+ offset H-NOTHING-ON-CLICK)
		   "Ignore Links" "" #t)
	     (send hyper-menu append-separator )
	     (send hyper-menu append  (+ offset H-MAKE-TAG-HERE)
		   "Make Tag")
	     (send hyper-menu append  (+ offset H-REMOVE-TAG)
		   "Remove Tag")
	     (send hyper-menu append  (+ offset H-SHOW-TAG)
		   "Go to Tag")
	     (send menu-bar append  hyper-menu "Hyper-Text")
	     (send menu-bar check  (+ offset H-FOLLOW-ON-CLICK) #t)
	     menu-bar))]
	[on-close (lambda () ((ivar mred:frame% on-close)))])
      (opt-lambda ([file-name #f])
	(super-init file-name #f)
	(wx:yield)
	(send (active-canvas) set-focus )
	(send (active-canvas) set-locking  #f)
	(set! menu-offset ((ivar mred:frame% next-menu-id)))))))



; for convenience and for the purpose of auto-loading:

(define mred:real-open-hyper-view
  (opt-lambda ([file-name #f][keep-locked? #t][tag "top"][relative? #f])
    (make-object mred:hyper-view-frame% file-name keep-locked? tag relative?)))

(define mred:real-open-hyper-make
  (opt-lambda ([file-name #f])
    (make-object mred:hyper-make-frame% file-name)))

(define mred:real-hyper-text-require
  (lambda ()
    #t))
