
(define string-lowercase!
  (lambda (s)
    (let loop ([n (sub1 (string-length s))])
      (unless (negative? n)
	 (string-set! s n
		      (char-downcase (string-ref s n)))
	 (loop (sub1 n))))))


(define eval-string
  (let ([do-eval
	 (lambda (str)
	   (let ([p (open-input-string str)])
	     (let loop ([v (void)])
	       (let ([e (read p)])
		 (if (eof-object? e)
		     v
		     (loop (eval e)))))))])
    (lambda (str . opt-error-handler)
      (if (and (pair? opt-error-handler)
	       (not (car opt-error-handler)))
	  (do-eval str)
	  (catch-error (if (null? opt-error-handler)
			   (lambda (escape debug s . objs)
			     (display s (current-error-port))
			     (map (lambda (obj)
				    (write obj (current-error-port)))
				  objs)
			     (display #\newline (current-error-port))
			     (escape #f))
			   (car opt-error-handler))
		       (do-eval str))))))

(define read-string
  (lambda (str . opt-error-handler)
    (apply eval-string (cons (string-append "'" str) opt-error-handler))))

(define read-potentially-unparsable-string
  read-string)

(define expr->string
  (lambda (v)
    (let* ([s (void)]
	   [write-to-s
	    (lambda (str)
	      (set! s str))]
	   [port (make-output-port write-to-s (lambda () #f))])
      (write v port)
      s)))

(define output-string%
  (make-class ()
	      (public
	       [string ""])
	      (private
	       [write-to-s
		(lambda (str)
		  (set! string (string-append string str)))])
	      (public
	       [port (make-output-port write-to-s (lambda () #f))])))
; (open-output-string)
;  -> (define os (make-object output-string%)) (ivar os port)
; (get-output-string p)
;  -> (ivar os string)
(constant output-string%)

(constant eval-string)
(constant read-string)
(constant read-potentially-unparsable-string)
(constant expr->string)

(define mred:newline-string (string #\newline))
(constant mred:newline-string)

