
#include "wx_obj.h"
#include "wx_list.h"
#include "wx_gdi.h"

@INCLUDE wxs.xci

@HEADER

@CLASSBASE wxFont "wx:font":"wx:object"

@CREATOR ();
@CREATOR (int,int,int,int,bool=0)
@CREATOR (int,ncstring,int,int,int,bool=0)

@ "get-family" : int GetFamily();
@ "get-font-id" : int GetFontId();
@ "get-style" : int GetStyle();
@ "get-point-size" : int GetPointSize();
@ "get-weight" : int GetWeight();
@ "get-underlined" : bool GetUnderlined();

@CONSTANT "wx:const-default" : int wxDEFAULT
@CONSTANT "wx:const-decorative" : int wxDECORATIVE
@CONSTANT "wx:const-roman" : int wxROMAN
@CONSTANT "wx:const-script" : int wxSCRIPT
@CONSTANT "wx:const-swiss" : int wxSWISS
@CONSTANT "wx:const-modern" : int wxMODERN
@CONSTANT "wx:const-teletype" : int wxTELETYPE

@CONSTANT "wx:const-variable" : int wxVARIABLE
@CONSTANT "wx:const-fixed" : int wxFIXED

@CONSTANT "wx:const-normal" : int wxNORMAL
@CONSTANT "wx:const-light" : int wxLIGHT
@CONSTANT "wx:const-bold" : int wxBOLD

@CONSTANT "wx:const-italic" : int wxITALIC
@CONSTANT "wx:const-slant" : int wxSLANT

@END


@CLASSBASE wxFontList "wx:font-list":"wx:object"

@CREATOR ();

@ "add-font" : void AddFont(wxFont!);
@ "find-or-create-font" : wxFont! FindOrCreateFont(int,int,int,int,bool=0)
@ "find-or-create-font" : wxFont! FindOrCreateFont(int,ncstring,int,int,int,bool=0)
@ "remove-font" : void RemoveFont(wxFont!);

@CONSTANT "wx:the-font-list" : wxFontList! wxTheFontList

@END


@CLASSBASE wxColour "wx:colour" : "wx:object"

@CREATOR ();
@CREATOR (ubyte,ubyte,ubyte);
@CREATOR (string);

@ "=" : wxColour% operator=(wxColour%);
@ "get" : void Get(ubyte*,ubyte*,ubyte*);
@ "ok?" : bool Ok();
@ "set" : void Set(ubyte,ubyte,ubyte);

@END


@CLASSBASE wxColourMap "wx:colour-map" : "wx:object"

@CREATOR ();

@ "create" : bool Create(int,custring,custring,custring);

@END


@CLASSBASE wxColourDatabase "wx:colour-database" : "wx:list"

@CREATOR (int);

@ "find-colour" : wxColour^ FindColour(string);
@ "find-name" : string FindName(wxColour%);
@ "initialize" : void Initialize();
@ "append" : void Append(string, wxColour!);

@CONSTANT "wx:the-colour-database" : wxColourDatabase! wxTheColourDatabase

@END


@CLASSBASE wxPoint "wx:point" : "wx:object"

@CREATOR ();
@CREATOR (float,float);

@IVAR "x" : float x
@IVAR "y" : float y

@END

@CLASSBASE wxIntPoint "wx:int-point" : "wx:object"

@CREATOR ();
@CREATOR (int,int)

@IVAR "x" : int x
@IVAR "y" : int y

@END

@CLASSBASE wxBrush "wx:brush" : "wx:object"

@CREATOR ();
@CREATOR (wxColour%,int);
@CREATOR (string,int);

@ "get-colour" : wxColour% GetColour();
@ "set-colour" : void SetColour(wxColour%);
@ "set-colour" : void SetColour(string);
@ "set-colour" : void SetColour(int,int,int);

@ "get-stipple" : wxBitmap! GetStipple();
@ "set-stipple" : void SetStipple(wxBitmap!);

@ "get-style" : int GetStyle();
@ "set-style" : void SetStyle(int);

@CONSTANT "wx:const-transparent" : int wxTRANSPARENT
@CONSTANT "wx:const-solid" : int wxSOLID
@CONSTANT "wx:const-bdiagonal-hatch" : int wxBDIAGONAL_HATCH
@CONSTANT "wx:const-crossdiag-hatch" : int wxCROSSDIAG_HATCH
@CONSTANT "wx:const-fdiagonal-hatch" : int wxFDIAGONAL_HATCH
@CONSTANT "wx:const-cross-hatch" : int wxCROSS_HATCH
@CONSTANT "wx:const-horizontal-hatch" : int wxHORIZONTAL_HATCH
@CONSTANT "wx:const-vertical-hatch" : int wxVERTICAL_HATCH

@END

@CLASSBASE wxBrushList "wx:brush-list" : "wx:list"

@CREATOR ();

@ "add-brush" : void AddBrush(wxBrush!);
@ "find-or-create-brush" : wxBrush! FindOrCreateBrush(wxColour!,int);
@ "find-or-create-brush" : wxBrush! FindOrCreateBrush(string,int);
@ "remove-brush" : void RemoveBrush(wxBrush!);

@CONSTANT "wx:the-brush-list" : wxBrushList! wxTheBrushList

@END

@CLASSBASE wxPen "wx:pen" : "wx:object"

@CREATOR ();
@CREATOR (wxColour%,int,int);
@CREATOR (string,int,int);

@ "get-width" : int GetWidth();
@ "set-width" : void SetWidth(int);
@ "get-cap" : int GetCap();
@ "set-cap" : void SetCap(int);
@ "get-join" : int GetJoin();
@ "set-join" : void SetJoin(int);

@ "get-colour" : wxColour% GetColour();
@ "set-colour" : void SetColour(wxColour%);
@ "set-colour" : void SetColour(string);
@ "set-colour" : void SetColour(int,int,int);

@ "get-stipple" : wxBitmap! GetStipple();
@ "set-stipple" : void SetStipple(wxBitmap!);

@ "get-style" : int GetStyle();
@ "set-style" : void SetStyle(int);

@CONSTANT "wx:const-join-bevel" : int wxJOIN_BEVEL
@CONSTANT "wx:const-join-miter" : int wxJOIN_MITER
@CONSTANT "wx:const-join-round" : int wxJOIN_ROUND

@CONSTANT "wx:const-cap-round" : int wxCAP_ROUND
@CONSTANT "wx:const-cap-projecting" : int wxCAP_PROJECTING
@CONSTANT "wx:const-cap-butt" : int wxCAP_BUTT

@END


@CLASSBASE wxPenList "wx:pen-list" : "wx:list"

@CREATOR ();

@ "add-pen" : void AddPen(wxPen!);
@ "find-or-create-pen" : wxPen! FindOrCreatePen(wxColour!,int,int);
@ "find-or-create-pen" : wxPen! FindOrCreatePen(string,int,int);
@ "remove-pen" : void RemovePen(wxPen!);

@CONSTANT "wx:the-pen-list" : wxPenList! wxThePenList

@END

@CLASSBASE wxCursor "wx:cursor" : "wx:object"

@CREATOR ();
@CREATOR (string);
@CREATOR (int);

@CONSTANT "wx:const-cursor-arrow" : int wxCURSOR_ARROW
@CONSTANT "wx:const-cursor-bullseye" : int wxCURSOR_BULLSEYE
@CONSTANT "wx:const-cursor-char" : int wxCURSOR_CHAR
@CONSTANT "wx:const-cursor-cross" : int wxCURSOR_CROSS
@CONSTANT "wx:const-cursor-hand" : int wxCURSOR_HAND
@CONSTANT "wx:const-cursor-ibeam" : int wxCURSOR_IBEAM
@CONSTANT "wx:const-cursor-left-button" : int wxCURSOR_LEFT_BUTTON
@CONSTANT "wx:const-cursor-magnifier" : int wxCURSOR_MAGNIFIER
@CONSTANT "wx:const-cursor-middle-button" : int wxCURSOR_MIDDLE_BUTTON
@CONSTANT "wx:const-cursor-no-entry" : int wxCURSOR_NO_ENTRY
@CONSTANT "wx:const-cursor-painr-brush" : int wxCURSOR_PAINT_BRUSH
@CONSTANT "wx:const-cursor-pencil" : int wxCURSOR_PENCIL
@CONSTANT "wx:const-cursor-point-left" : int wxCURSOR_POINT_LEFT
@CONSTANT "wx:const-cursor-point-right" : int wxCURSOR_POINT_RIGHT
@CONSTANT "wx:const-cursor-question-arrow" : int wxCURSOR_QUESTION_ARROW
@CONSTANT "wx:const-cursor-right-button" : int wxCURSOR_RIGHT_BUTTON
@CONSTANT "wx:const-cursor-sizenesw" : int wxCURSOR_SIZENESW
@CONSTANT "wx:const-cursor-sizens" : int wxCURSOR_SIZENS
@CONSTANT "wx:const-cursor-sizenwse" : int wxCURSOR_SIZENWSE
@CONSTANT "wx:const-cursor-sizewe" : int wxCURSOR_SIZEWE
@CONSTANT "wx:const-cursor-sizing" : int wxCURSOR_SIZING
@CONSTANT "wx:const-cursor-spraycan" : int wxCURSOR_SPRAYCAN
@CONSTANT "wx:const-cursor-wait" : int wxCURSOR_WAIT
@CONSTANT "wx:const-cursor-watch" : int wxCURSOR_WATCH

@END

@CLASSBASE wxIcon "wx:icon" : "wx:object"

@CREATOR ();
@CREATOR (string);

@END

@CLASSBASE wxFontNameDirectory "wx:font-name-directory":"wx:object"

@ "get-screen-name" : nstring GetScreenName(int,int,int);
@ "get-post-script-name" : nstring GetPostScriptName(int,int,int);
@ "get-afm-name" : nstring GetAFMName(int,int,int);

@ "get-new-font-id" :   int GetNewFontId()
@ "initialize" : void Initialize(int,int,string);

@ "get-font-id" : int GetFontId(string);
@ "get-font-name" : nstring GetFontName(int);
@ "get-family" : int GetFamily(int);

@ "find-or-create-font-id" : int FindOrCreateFontId(cstring,int);

@CONSTANT "wx:the-font-name-directory" : wxFontNameDirectory% wxTheFontNameDirectory

@END
