
#include "wx_list.h"
#include "wx_hash.h"
#include "wx_utils.h"

@INCLUDE wxs.xci

@HEADER

@CLASSBASE wxNode "wx:node":"wx:object"

@ "data" : wxObject! Data();
@ "next" : wxNode! Next();
@ "previous" : wxNode! Previous();
@ "set-data" : void SetData(wxObject!);

@END

@CLASSBASE wxList "wx:list" : "wx:object"

@CREATOR ()
@CREATOR (unsigned)
// @CREATOR (int, wxObject*[]);

@ "append" : wxNode! Append(wxObject!);
@ "append" : wxNode! Append(long,wxObject!);
@ "append" : wxNode! Append(string,wxObject!);

@ "clear" : void Clear();
// UNSAFE -- @ "set-delete-contents" : void DeleteContents(bool);
@ "delete-node" : bool DeleteNode(wxNode!);
@ "delete-object" : bool DeleteObject(wxObject!);
@ "find" : wxNode! Find(long);
@ "find" : wxNode! Find(string);
@ "first" : wxNode! First();
@ "insert" : wxNode! Insert(wxNode!, wxObject!);
@ "insert" : wxNode! Insert(wxObject!);
@ "last" : wxNode! Last();
@ "member" : wxNode! Member(wxObject!);
@ "nth" : wxNode! Nth(int);
@ "number" : int Number();

@END

@CLASSBASE wxHashTable "wx:hash-table" : "wx:list"

@CREATOR (int,int=1000)

@ "begin-find" : void BeginFind();
@ "clear" : void Clear();
@ "delete" : void Delete(long);
@ "delete" : void Delete(string);
@ "get" : wxObject^ Get(long);
@ "get" : wxObject^ Get(string);
@ "make-key" : long MakeKey(string);
@ "next" : wxNode^ Next();
@ "put" : void Put(long, wxObject!);
@ "put" : void Put(string, wxObject!);

@CONSTANT "wx:const-key-integer" : int wxKEY_INTEGER
@CONSTANT "wx:const-key-string" : int wxKEY_STRING

@END

@CLASSBASE wxPathList "wx:path-list" : "wx:list"

@CREATOR ();

@ "add-env-list" : void AddEnvList(string);
@ "add" : void Add(string)
@ "find-valid-path" : string FindValidPath(string);
@ "member?" : bool Member(string);

@END

@CLASSBASE wxStringList "wx:string-list" : "wx:list"

@CREATOR ();

@ "add" : void Add(string);
@ "delete" : void Delete(string);
@ "sort" : void Sort();
@ "member?" : bool Member(string);

@END
