
#include "wx_media.h"

@INCLUDE wxs.xci

@HEADER

@MACRO rNULL = return NULL;
@MACRO rFALSE = return FALSE;
@MACRO rZERO = return 0;

@CLASSBASE wxMediaCanvas "wx:media-canvas" : "wx:canvas"

@CREATOR (wxFrame!,int=-1,int=-1,int=-1,int=-1, string="",long=0,int=100,wxMediaEdit^=NULL);

@CLASSID wxTYPE_MEDIA_CANVAS

@ "set-media" : void SetMedia(wxMediaBuffer^,bool=TRUE);
@ "get-media" : wxMediaBuffer^ GetMedia();

@ v "scroll" : void Scroll(int,int,bool);
@ v "scroll" : void Scroll(int,int);
@ v "on-set-focus" : void OnSetFocus();
@ v "on-kill-focus" : void OnKillFocus();

@ "is-focus-on?" : bool IsFocusOn();

@ "force-display-focus" : void ForceDisplayFocus(bool);

@INCLUDE wxs_win.xci

@CONSTANT "wx:const-mcanvas-no-h-scroll" : long wxMCANVAS_NO_H_SCROLL
@CONSTANT "wx:const-mcanvas-no-v-scroll" : long wxMCANVAS_NO_V_SCROLL
@CONSTANT "wx:const-mcanvas-hide-h-scroll" : long wxMCANVAS_HIDE_H_SCROLL
@CONSTANT "wx:const-mcanvas-hide-v-scroll" : long wxMCANVAS_HIDE_V_SCROLL

@END

@CLASSBASE wxMediaAdmin "wx:media-admin":"wx:object"

@CREATOR ();

@ V "get-dc" : wxDC^ GetDC(float?=NULL,float?=NULL); : : : rNULL
@ V "get-view" : void GetView(float?,float?,float?,float?,bool=FALSE);
@ V "scroll-to" : bool ScrollTo(float,float,float,float,bool=TRUE,int=0); : : : rFALSE
@ V "grab-caret" : void GrabCaret();
@ V "resized" : void Resized(bool);
@ V  "needs-update" : void NeedsUpdate(float,float,float,float);
@ V "set-cursor" : void SetCursor(wxCursor!);

@END

@CLASSBASE wxSnipAdmin "wx:snip-admin":"wx:object"

@CREATOR ();

@ V "get-media" : wxMediaBuffer^ GetMedia(); : : : rNULL
@ V "get-dc" : wxDC! GetDC(); : : : rNULL
@ V "get-view-size" : void GetViewSize(float?, float?);
@ V "scroll-to" : bool ScrollTo(wxSnip!, float,float,float,float, bool,int=0); : : : rFALSE
@ V "set-caret-owner" : void SetCaretOwner(wxSnip!);
@ V "resized" : void Resized(wxSnip!, bool);
@ V "needs-update" : void NeedsUpdate(wxSnip!, float,float,float,float);
@ V "release-snip" : bool ReleaseSnip(wxSnip!); : : : rFALSE
@ V "set-cursor" : void SetCursor(wxCursor!);

@END



@CLASSBASE wxSnipClass "wx:snip-class" : "wx:object"

@CREATOR ();

@IVAR "classname" : string classname
@IVAR "version" : int version

@ V "read" : wxSnip^ Read(wxMediaStreamIn%); : : : rNULL
@ v "read-header" : bool ReadHeader(wxMediaStreamIn%);
@ v "read-done" : void ReadDone();
@ v "write-header" : bool WriteHeader(wxMediaStreamOut%);
@ v "write-done" : void WriteDone();

@END


@CLASSBASE wxSnipClassList "wx:snip-class-list" : "wx:object"

@ "find" : wxSnipClass^ Find(string);
@ "find-position" : short FindPosition(wxSnipClass!);
@ "add" : void Add(wxSnipClass!);
@ "number" : int Number();
@ "nth" : wxSnipClass^ Nth(int);

@CONSTANT "wx:the-snip-class-list" : wxSnipClassList% wxTheSnipClassList

@END


@CLASSBASE wxKeymap "wx:keymap":"wx:object"

class KeyCallbackToSchemeRec : public wxObject
{
 public:
  Scheme_Object *f;
};

class MouseCallbackToSchemeRec : public wxObject
{
 public:
  Scheme_Object *f;
};

class ErrorCallbackToSchemeRec : public wxObject
{
 public:
  Scheme_Object *f;
};

static int KeyCallbackToScheme(wxMediaBuffer *, wxKeyEvent &, KeyCallbackToSchemeRec *data);
static int MouseCallbackToScheme(wxMediaBuffer *, wxMouseEvent &, MouseCallbackToSchemeRec *data);
static void ErrorCallbackToScheme(ErrorCallbackToSchemeRec *data, char *str);

@MACRO bCallback =
@MACRO ubSetup = KeyCallbackToSchemeRec *cb = new KeyCallbackToSchemeRec;
@MACRO ubCallback = (wxKeyFunction)KeyCallbackToScheme

@MACRO bCallback2 = 
@MACRO ubSetup2 = MouseCallbackToSchemeRec *cb = new MouseCallbackToSchemeRec;
@MACRO ubCallback2 = (wxMouseFunction)MouseCallbackToScheme

@MACRO bCallback3 = 
@MACRO ubSetup3 = ErrorCallbackToSchemeRec *cb = new ErrorCallbackToSchemeRec;
@MACRO ubCallback3 = (wxKeyErrorFunction)ErrorCallbackToScheme

@MACRO ubData = NULL
@MACRO ubSetData = cb->f = p[1]; WXGC_IGNORE(cb->f); x2 = cb;

@MACRO ubSetData3 = cb->f = p[0]; WXGC_IGNORE(cb->f); x1 = cb;

@CREATOR ();

@ "get-double-click-interval" : long GetDoubleClickInterval();
@ "set-double-click-interval" : void SetDoubleClickInterval(long);

@ "handle-key-event" : bool HandleKeyEvent(wxMediaBuffer!,wxKeyEvent%);
@ "handle-mouse-event" : bool HandleMouseEvent(wxMediaBuffer!,wxMouseEvent%);
@ "break-sequence" : void BreakSequence();
@ "map-function" : void MapFunction(string,string);
@ "implies-shift" : void ImpliesShift(string);
@ "add-key-function" : void AddKeyFunction(string,wxKeyFunction/bCallback/ubCallback/cCallback,-unknown#void*=NULL); : : ubSetup / ubSetData
@ "add-mouse-function" : void AddMouseFunction(string,wxMouseFunction/bCallback2/ubCallback2/cCallback2,-unknown#void*=NULL); : : ubSetup2 / ubSetData
@ "call-function" : bool CallFunction(string,wxMediaBuffer!,wxKeyEvent%);
@ "call-function" : bool CallFunction(string,wxMediaBuffer!,wxMouseEvent%);
@ "set-error-callback" : void SetErrorCallback(wxKeyErrorFunction/bCallback3/ubCallback3/cCallback3,-unknown#void*=NULL); : : ubSetup3 / ubSetData3
@ "set-next-keymap" : void SetNextKeymap(wxKeymap^);

@END

static int KeyCallbackToScheme(wxMediaBuffer *media, wxKeyEvent &event, 
			       KeyCallbackToSchemeRec *data)
{
  extern Scheme_Object *objscheme_bundle_wxKeyEvent(wxKeyEvent *);
  Scheme_Object *p[2], *obj;
  jmp_buf savebuf;

  p[0] = objscheme_bundle_wxMediaBuffer(media);
  p[1] = objscheme_bundle_wxKeyEvent(&event);

#ifndef WXS_CANT_ASSIGN_STRUCTURES
  savebuf = scheme_error_buf;
#else
  memcpy(&savebuf, &scheme_error_buf, sizeof(jmp_buf));
#endif

  if (!setjmp(scheme_error_buf)) {
    obj = scheme_apply(data->f, 2, p);
    return objscheme_unbundle_bool(obj, "Scheme key callback");
  }

#ifndef WXS_CANT_ASSIGN_STRUCTURES
  scheme_error_buf = savebuf;
#else
  memcpy(&scheme_error_buf, &savebuf, sizeof(jmp_buf));
#endif
 
  return 0;
}

static int MouseCallbackToScheme(wxMediaBuffer *media, wxMouseEvent &event, 
				 MouseCallbackToSchemeRec *data)
{
  extern Scheme_Object *objscheme_bundle_wxMouseEvent(wxMouseEvent *);
  Scheme_Object *p[2], *obj;
  jmp_buf savebuf;

  p[0] = objscheme_bundle_wxMediaBuffer(media);
  p[1] = objscheme_bundle_wxMouseEvent(&event);

#ifndef WXS_CANT_ASSIGN_STRUCTURES
  savebuf = scheme_error_buf;
#else
  memcpy(&savebuf, &scheme_error_buf, sizeof(jmp_buf));
#endif

  if (!setjmp(scheme_error_buf)) {
    obj = scheme_apply(data->f, 2, p);
    return objscheme_unbundle_bool(obj, "Scheme mouse callback");
  }

#ifndef WXS_CANT_ASSIGN_STRUCTURES
  scheme_error_buf = savebuf;
#else
  memcpy(&scheme_error_buf, &savebuf, sizeof(jmp_buf));
#endif 
  
  return 0;
}

static void ErrorCallbackToScheme(ErrorCallbackToSchemeRec *data, char *err)
{
  Scheme_Object *p[1];
  jmp_buf savebuf;

  p[0] = objscheme_bundle_string(err);

#ifndef WXS_CANT_ASSIGN_STRUCTURES
  savebuf = scheme_error_buf;
#else
  memcpy(&savebuf, &scheme_error_buf, sizeof(jmp_buf));
#endif

  if (!setjmp(scheme_error_buf)) {
    scheme_apply(data->f, 1, p);
  }

#ifndef WXS_CANT_ASSIGN_STRUCTURES
  scheme_error_buf = savebuf;
#else
  memcpy(&scheme_error_buf, &savebuf, sizeof(jmp_buf));
#endif
}


@CLASSBASE wxMediaWordbreakMap "wx:media-wordbreak-map" : "wx:object"

@CREATOR ()

@ "set-map" : void SetMap(int,int);
@ "get-map" : int GetMap(int);

@ "adjust-usage" : void AdjustUsage(bool)
@ "is-used?" : bool IsUsed();

@CONSTANT "wx:the-media-wordbreak-map" : wxMediaWordbreakMap% wxTheMediaWordbreakMap

@END

