
#include "wx_media.h"

@INCLUDE wxs.xci

@HEADER

@SET TYPE = float
@SET NOTEST = 1
@INCLUDE list.xci

@MACRO rNULL = return NULL;
@MACRO rFALSE = return FALSE;
@MACRO rZERO = return 0;

@CLASSBASE wxMediaEdit "wx:media-edit" : "wx:media-buffer"

@CREATOR (float=1.0,float[]=NULL/bList/ubList/cList,-int=0); : /methListSet[float.1.1.2]// : /glueListSet[float.1.1.2]//

@CLASSID wxTYPE_MEDIA_EDIT

@VAR Scheme_Object *scroll_closure;

@SETMARK X = 
@SETMARK Y = v
@SETMARK Z = v
@INCLUDE wxs_mbuf.xci

@ "get-position" : void GetPosition(long?,long?=NULL);
@ "get-start-position" : long GetStartPosition();
@ "get-end-position" : long GetEndPosition();
@ "set-position" : void SetPosition(long,long=-1,bool=FALSE,bool=TRUE);
@ "set-position-bias-scroll" : void SetPositionBiasScroll(int,long,long=-1,bool=FALSE,bool=TRUE);
@ "move-position" :  void MovePosition(long,bool=FALSE,int=wxMOVE_SIMPLE);
@ "scroll-to-position" : bool ScrollToPosition(long,bool=FALSE,long=-1,int=0);
@ "get-visible-position-range" : void GetVisiblePositionRange(long?,long?);
@ "get-visible-line-range" : void GetVisibleLineRange(long?,long?);

@ "set-anchor" : void SetAnchor(bool);
@ "get-anchor" : bool GetAnchor();

@ "flash-on" : void FlashOn(long,long,bool=FALSE,bool=TRUE,long=500);
@ "flash-off" : void FlashOff();

@ "insert" : void Insert(string,long,long=-1);
@ "insert" : void Insert(string);
@ "insert" : void Insert(wxSnip!,long,long=-1);
@ "insert" : void Insert(uchar);
@ "insert" : void Insert(uchar,long,long=-1);

@ "delete" : void Delete(long, long=-1);
@ "delete" : void Delete();
@ "clear" :  void Clear();
@ "erase" :  void Erase();

@ "cut" :  void Cut(bool,long,long,long=-1);
@ "copy" : void Copy(bool,long,long,long=-1);
@ "paste" : void Paste(long,long,long=-1);
@ "kill" : void Kill(long,long,long);

@ "change-style" : void ChangeStyle(wxStyleDelta^,long,long=-1);
@ "change-style" : void ChangeStyle(wxStyle^,long=-1,long=-1);
			
@ "find-position" : long FindPosition(float,float,bool?=NULL,bool?=NULL);
@ "find-line" : long FindLine(float,bool?=NULL);
@ "find-position-in-line" : long FindPositionInLine(long,float,bool?=NULL,bool?=NULL);

@ "position-line" : long PositionLine(long,bool=FALSE);
@ "position-location" :  void PositionLocation(long,float?=NULL,float?=NULL,bool=TRUE,bool=FALSE,bool=FALSE);
@ "line-location" : float LineLocation(long,bool=TRUE);

@ "line-start-position" : long LineStartPosition(long,bool=TRUE);
@ "line-end-position" : long LineEndPosition(long,bool=TRUE);
@ "line-length" : long LineLength(long);
@ "last-position" : long LastPosition();
@ "last-line" : long LastLine();
  
@ "find-string" : long FindString(string,int=1,long=-1,long=-1,bool=TRUE,bool=TRUE);

@SET TYPE = long
@SET NOTEST = 1
@INCLUDE list.xci

@ "find-string-all" : long[]/bReturnList[long.1]//cList FindStringAll(string,-long*,int=1,long=-1,long=-1,bool=TRUE,bool=TRUE);

@ "find-snip" : wxSnip^ FindSnip(long,int,long?=NULL)
@ "get-snip-position-and-location" : void GetSnipPositionAndLocation(wxSnip!,long*,float*,float*);
@ "get-snip-position" : long GetSnipPosition(wxSnip!);

@ "get-text" : string GetText(long=-1,long=-1,bool=FALSE,bool=FALSE);
@ "get-character" : uchar GetCharacter(long);

@ "load-file" : bool LoadFile(nstring=NULL,int=wxMEDIA_FF_GUESS);
@ "save-file" : bool SaveFile(nstring=NULL,int=wxMEDIA_FF_SAME);

@ "read-from-file" : bool ReadFromFile(wxMediaStreamIn%,long);
@ "write-to-file" : bool WriteToFile(wxMediaStreamOut%,long,long=-1);

@ "get-file-format" : int GetFileFormat();
@ "set-file-format" : void SetFileFormat(int);

@MACRO checkNull = if (!x0) x0 = &_x0;

@ "get-tabs" : float[]/bReturnList[float.0]//cList GetTabs(int?=NULL,float?=NULL,bool?=NULL); : : /checkNull/
@ "set-tabs" : void SetTabs(float[]/bList/ubList/cList,-int,float=wxTAB_WIDTH,bool=TRUE); : /methListSet[float.0.0.1]// : /glueListSet[float.0.0.1]//

@ "add-editor-functions" : void AddEditorFunctions(wxKeymap!);

@ v "on-insert" : bool OnInsert(long,long);
@ v "after-insert" : void AfterInsert(long,long);
@ v "on-delete" : bool OnDelete(long,long);
@ v "after-delete" : void AfterDelete(long,long);
@ v "on-edit-sequence" : void OnEditSequence();
@ v "after-edit-sequence" : void AfterEditSequence();

@ v "get-region-data" : wxBufferData^ GetRegionData(long,long);
@ v "set-region-data" : void SetRegionData(long, long, wxBufferData^);

@ "find-wordbreak" : void FindWordbreak(long?,long?,int);

static void WordbreakCallbackToScheme(wxMediaEdit *,long*,long*,int,Scheme_Object *);

@MACRO ubCallback = (wxWordbreakFunc)WordbreakCallbackToScheme
@MACRO ubData = p[0]

@MACRO ubCallback2 = (wxClickbackFunc)ClickbackToScheme
@MACRO ubData2 = p[2]
@MACRO cCallback2 = SCHEME_PROCP({x})

@ "set-wordbreak-func" : void SetWordbreakFunc(wxWordbreakFunc//ubCallback/cCallback,-unknown#void*//ubData);
@ "set-clickback" : void SetClickback(long,long,wxClickbackFunc//ubCallback2/cCallback2,-unknown#void*//ubData2,wxStyleDelta^=NULL);
@ "remove-clickback" : void RemoveClickback(long,long);

static void WordbreakCallbackToScheme(wxMediaEdit *media,
				      long *start, long *end,
				      int reason,
				      Scheme_Object *f)
{
  Scheme_Object *p[4], *s, *e;
  jmp_buf savebuf;

#ifndef WXS_CANT_ASSIGN_STRUCTURES
  savebuf = scheme_error_buf;
#else
  memcpy(&savebuf, &scheme_error_buf, sizeof(jmp_buf));
#endif

  if (!setjmp(scheme_error_buf)) {
    p[0] = objscheme_bundle_wxMediaEdit(media);
    p[1] = scheme_make_pair(s = objscheme_bundle_integer(*start), scheme_null);
    p[2] = scheme_make_pair(e = objscheme_bundle_integer(*end), scheme_null);
    p[3] = scheme_make_integer(reason);

    scheme_apply(f, 4, p);
    *start = objscheme_unbundle_integer(s, "Scheme wordbreak callback");
    *end = objscheme_unbundle_integer(e, "Scheme wordbreak callback");
  }

#ifndef WXS_CANT_ASSIGN_STRUCTURES
  scheme_error_buf = savebuf;
#else
  memcpy(&scheme_error_buf, &savebuf, sizeof(jmp_buf));
#endif
}

static void ClickbackToScheme(wxMediaEdit *media,
			      long start, long end,
			      Scheme_Object *f)
{
  Scheme_Object *p[3];
  jmp_buf savebuf;

  p[0] = objscheme_bundle_wxMediaEdit(media);
  p[1] = objscheme_bundle_integer(start);
  p[2] = objscheme_bundle_integer(end);

#ifndef WXS_CANT_ASSIGN_STRUCTURES
  savebuf = scheme_error_buf;
#else
  memcpy(&savebuf, &scheme_error_buf, sizeof(jmp_buf));
#endif

  if (!setjmp(scheme_error_buf))
    scheme_apply(f, 3, p);

#ifndef WXS_CANT_ASSIGN_STRUCTURES
  scheme_error_buf = savebuf;
#else
  memcpy(&scheme_error_buf, &savebuf, sizeof(jmp_buf));
#endif
}

@CONSTANT "wx:const-edit-undo" : int wxEDIT_UNDO
@CONSTANT "wx:const-edit-redo" : int wxEDIT_REDO
@CONSTANT "wx:const-edit-clear" : int wxEDIT_CLEAR
@CONSTANT "wx:const-edit-cut" : int wxEDIT_CUT
@CONSTANT "wx:const-edit-copy" : int wxEDIT_COPY
@CONSTANT "wx:const-edit-paste" : int wxEDIT_PASTE
@CONSTANT "wx:const-edit-kill" : int wxEDIT_KILL
@CONSTANT "wx:const-edit-insert-text-box" : int wxEDIT_INSERT_TEXT_BOX
@CONSTANT "wx:const-edit-insert-graphic-box" : int wxEDIT_INSERT_GRAPHIC_BOX
@CONSTANT "wx:const-edit-insert-image" : int wxEDIT_INSERT_IMAGE

@CONSTANT "wx:const-move-simple" : int wxMOVE_SIMPLE
@CONSTANT "wx:const-move-line" : int wxMOVE_LINE
@CONSTANT "wx:const-move-page" : int wxMOVE_PAGE
@CONSTANT "wx:const-move-word" : int wxMOVE_WORD

@CONSTANT "wx:const-media-ff-guess" : int wxMEDIA_FF_GUESS
@CONSTANT "wx:const-media-ff-std" : int wxMEDIA_FF_STD
@CONSTANT "wx:const-media-ff-text" : int wxMEDIA_FF_TEXT
@CONSTANT "wx:const-media-ff-text-force-cr" : int wxMEDIA_FF_TEXT_FORCE_CR
@CONSTANT "wx:const-media-ff-same" : int wxMEDIA_FF_SAME

@CONSTANT "wx:const-snip-before-or-null" : int wxSNIP_BEFORE_OR_NULL
@CONSTANT "wx:const-snip-before" : int wxSNIP_BEFORE
@CONSTANT "wx:const-snip-after" : int wxSNIP_AFTER
@CONSTANT "wx:const-snip-after-or-null" : int wxSNIP_AFTER_OR_NULL

@CONSTANT "wx:const-break-for-caret" : int wxBREAK_FOR_CARET
@CONSTANT "wx:const-break-for-line" : int wxBREAK_FOR_LINE
@CONSTANT "wx:const-break-for-selection" : int wxBREAK_FOR_SELECTION

@END


