
#include "wx_media.h"

@INCLUDE wxs.xci

@HEADER

@CLASSBASE wxSnip "wx:snip":"wx:object"

@CREATOR ();

@CONSTANT "wx:const-snip-can-append" : int wxSNIP_CAN_APPEND
@CONSTANT "wx:const-snip-newline" : int wxSNIP_NEWLINE
@CONSTANT "wx:const-snip-hard-newline" : int wxSNIP_HARD_NEWLINE
@CONSTANT "wx:const-snip-is-text" : int wxSNIP_IS_TEXT
@CONSTANT "wx:const-snip-invisible" : int wxSNIP_INVISIBLE
@CONSTANT "wx:const-snip-handles-events" : int wxSNIP_HANDLES_EVENTS
@CONSTANT "wx:const-snip-width-depends-on-x" : int wxSNIP_WIDTH_DEPENDS_ON_X
@CONSTANT "wx:const-snip-height-depends-on-x" : int wxSNIP_HEIGHT_DEPENDS_ON_X
@CONSTANT "wx:const-snip-width-depends-on-y" : int wxSNIP_WIDTH_DEPENDS_ON_Y
@CONSTANT "wx:const-snip-height-depends-on-y" : int wxSNIP_HEIGHT_DEPENDS_ON_Y
@CONSTANT "wx:const-snip-anchored" : int wxSNIP_ANCHORED
@CONSTANT "wx:const-snip-uses-buffer-path" : int wxSNIP_USES_BUFFER_PATH

@IVAR r "count" : long count
@IVAR r "flags" : long flags
@IVAR r "style" : wxStyle! style
@IVAR "snipclass" : wxSnipClass^ snipclass

@ "get-admin" : wxSnipAdmin! GetAdmin();
@ "set-admin" : void SetAdmin(wxSnipAdmin!);

@ "set-count" : void SetCount(long);
@ "set-flags" : void SetFlags(long);

@ "is-owned?" : bool IsOwned();
@ "release-from-owner" : bool ReleaseFromOwner();

@INCLUDE wxs_snip.xci

@ "next" : wxSnip^ Next();
@ "previous" : wxSnip^ Previous();

@END


@CLASSBASE wxTextSnip "wx:text-snip":"wx:snip"

@CREATOR (long=0);

@INCLUDE wxs_snip.xci

@ "insert" : void Insert(string,long,long=0);
@ "read" : void Read(long,wxMediaStreamIn%);

@END


@CLASSBASE wxTabSnip "wx:tab-snip":"wx:text-snip"

@CREATOR ();

@INCLUDE wxs_snip.xci

@END


@CLASSBASE wxImageSnip "wx:image-snip":"wx:snip"

@CREATOR (nstring=NULL,long=0,bool=FALSE);

@INCLUDE wxs_snip.xci

@ "load-file" : void LoadFile(nstring,long,bool=FALSE);

@ "get-filename" : nstring GetFilename(bool?);
@ "get-filetype" : long GetFiletype();

@ "set-bitmap" : void SetBitmap(wxBitmap!);

@ "set-offset" : void SetOffset(float, float);

@END


@CLASSBASE wxMediaSnip "wx:media-snip" : "wx:snip"

@CREATOR (wxMediaBuffer^=NULL,bool=TRUE,int=wxMSNIPBOX_XMARGIN,int=wxMSNIPBOX_YMARGIN,int=wxMSNIPBOX_XMARGIN,int=wxMSNIPBOX_YMARGIN,int=wxMSNIPBOX_XINSET,int=wxMSNIPBOX_YINSET,int=wxMSNIPBOX_XINSET,int=wxMSNIPBOX_YINSET);

@ "get-this-media" : wxMediaBuffer^ GetThisMedia();

@CONSTANT "wx:const-msnipbox-xmargin" : int wxMSNIPBOX_XMARGIN
@CONSTANT "wx:const-msnipbox-ymargin" : int wxMSNIPBOX_YMARGIN
@CONSTANT "wx:const-msnipbox-xinset" : int wxMSNIPBOX_XINSET
@CONSTANT "wx:const-msnipbox-yinset" : int wxMSNIPBOX_YINSET

@INCLUDE wxs_snip.xci

@ "set-max-width" : void SetMaxWidth(float);
@ "set-max-height" : void SetMaxHeight(float);
@ "set-max-width" : float GetMaxWidth();
@ "set-max-height" : float GetMaxHeight();
@ "set-min-width" : void SetMinWidth(float);
@ "set-min-height" : void SetMinHeight(float);
@ "set-min-width" : float GetMinWidth();
@ "set-min-height" : float GetMinHeight();

@ "show-border" : void ShowBorder(bool);
@ "border-visible?" : bool BorderVisible();

@ "set-margin" : void SetMargin(int,int,int,int);
@ "get-margin" :void GetMargin(int*,int*,int*,int*);
@ "set-inset" :void SetInset(int,int,int,int);
@ "get-inset" :void GetInset(int*,int*,int*,int*);

@END

@MACRO rZERO = return NULL;

@CLASSBASE wxBufferDataClass "wx:buffer-data-class" : "wx:object"

@CREATOR ()

@IVAR "classname" : string classname
@IVAR "required" : bool required

@ V "read" : wxBufferData^ Read(wxMediaStreamIn%); : : : : rZERO

@END

@CLASSBASE wxBufferDataClassList "wx:buffer-data-class-list" : "wx:object"

@CREATOR ()

@ "find" : wxBufferDataClass^ Find(string);
@ "find-position" : short FindPosition(wxBufferDataClass!);
@ "add" : void Add(wxBufferDataClass!);
@ "number" : int Number();
@ "nth" : wxBufferDataClass^ Nth(int);

@CONSTANT "wx:the-buffer-data-class-list" : wxBufferDataClassList% wxTheBufferDataClassList

@END

@CLASSBASE wxBufferData "wx:buffer-data" : "wx:object"

@CREATOR ()

@IVAR "dataclass" : wxBufferDataClass^ dataclass
@IVAR "next" : wxBufferData^ next

@ V "write" : bool Write(wxMediaStreamOut%); : : : : rZERO

@END

